local TradeSkillFrameReset = TradeSkillFrame_LoadUI

TradeSkillFrame_LoadUI = function()
	TradeSkillFrameReset()
	TradeSkillFrame_SetSelection=TradeSkillFrameSSOverride

	TradeSkillFrame:SetAttribute("UIPanelLayout-width", 724);
	TradeSkillFrame:SetWidth(724);
	TradeSkillFrame:SetHeight(512);
	TradeSkillRankFrame:SetWidth(606);
	TradeSkillListScrollFrame:ClearAllPoints();
	TradeSkillListScrollFrame:SetPoint("LEFT", TradeSkillFrame, "LEFT", 18, 5);
	TradeSkillListScrollFrame:SetHeight(310);
	TRADE_SKILLS_DISPLAYED = 20
    for i = 8 + 1, 20 do
       local button = CreateFrame("Button", "TradeSkillSkill" .. i, TradeSkillFrame, "TradeSkillSkillButtonTemplate");
       button:SetID(i);
       button:Hide();
       button:ClearAllPoints();
       button:SetPoint("TOPLEFT", getglobal("TradeSkillSkill" .. (i-1)), "BOTTOMLEFT", 0, 1);
    end;
	TradeSkillDetailScrollFrame:ClearAllPoints();
	TradeSkillDetailScrollFrame:SetPoint("LEFT", TradeSkillListScrollFrame, "RIGHT", 50, -10);
	TradeSkillDetailScrollFrame:SetHeight(310);
	TradeSkillCreateAllButton:ClearAllPoints();
	TradeSkillCreateAllButton:SetPoint("BOTTOMLEFT", TradeSkillFrame, "BOTTOMLEFT", 18, 80);
	TradeSkillDecrementButton:ClearAllPoints();
	TradeSkillDecrementButton:SetPoint("LEFT", TradeSkillCreateAllButton, "RIGHT", 3, 0)
	TradeSkillInputBox:ClearAllPoints();
	TradeSkillInputBox:SetPoint("LEFT", TradeSkillDecrementButton, "RIGHT", 4, -1)
	TradeSkillIncrementButton:ClearAllPoints();
	TradeSkillIncrementButton:SetPoint("LEFT", TradeSkillInputBox, "RIGHT", 0, 1)
	TradeSkillCreateButton:ClearAllPoints();
	TradeSkillCreateButton:SetPoint("LEFT", TradeSkillIncrementButton, "RIGHT", 3, 0)
	TradeSkillCancelButton:ClearAllPoints();
	TradeSkillCancelButton:SetPoint("BOTTOMRIGHT", TradeSkillFrame, "BOTTOMRIGHT", -40, 80);
	local regions = {TradeSkillFrame:GetRegions()}
	for _,r in ipairs(regions) do
		if (r:IsObjectType("Texture")) then
			if (r:GetTexture() == [[Interface\ClassTrainerFrame\UI-ClassTrainer-HorizontalBar]]) then
				local src,_,dst,_,_ = r:GetPoint(1)
				if (src == "TOPLEFT" and dst == "TOPLEFT") then
					TradeSkillFrameBA=r;
				elseif (src == "LEFT" and dst == "RIGHT") then
					TradeSkillFrameBB=r;
				end;
			elseif (r:GetTexture()) then
			local which,vert,horz = r:GetTexture():match("^Interface\\[A-Za-z]+\\UI%-[A-Za-z]+%-(([A-Z][a-z]+)([A-Z][a-z]+))$")
				if (which == "TopLeft") then
					TradeSkillFrameTL=r;
				elseif (which == "TopRight") then
					TradeSkillFrameTR=r;
				elseif (which == "BotRight") then
					TradeSkillFrameBR=r;
				elseif (which == "BotLeft") then
					TradeSkillFrameBL=r;
				end;
			end;
		end;
	end;
	TradeSkillFrameBA:SetWidth(16);
	TradeSkillFrameBA:SetHeight(256);
	TradeSkillFrameBA:SetTexture("Interface\\AddOns\\TradeSkillHD\\UI-TradeSkill-VerticalBar");
	TradeSkillFrameBA:SetTexCoord(0,.25,0,1);
	TradeSkillFrameBB:ClearAllPoints();
	TradeSkillFrameBB:SetPoint("TOP", TradeSkillHorizontalBarLeft, "BOTTOM",0,0);
	TradeSkillFrameBB:SetWidth(16);
	TradeSkillFrameBB:SetHeight(256);
	TradeSkillFrameBB:SetTexture("Interface\\AddOns\\TradeSkillHD\\UI-TradeSkill-VerticalBar");
	TradeSkillFrameBB:SetTexCoord(.25,.50,0,1);
	TradeSkillFrameTL:SetWidth(512);
	TradeSkillFrameTL:SetHeight(256);
    TradeSkillFrameTL:SetTexture("Interface\\AddOns\\TradeSkillHD\\UI-TradeSkill-TopLeft");
	TradeSkillFrameBL:SetWidth(512);
	TradeSkillFrameBL:SetHeight(256);
    TradeSkillFrameBL:SetTexture("Interface\\AddOns\\TradeSkillHD\\UI-TradeSkill-BottomLeft");
	TradeSkillFrameTR:SetWidth(256);
	TradeSkillFrameTR:SetHeight(256);
    TradeSkillFrameTR:SetTexture("Interface\\AddOns\\TradeSkillHD\\UI-TradeSkill-TopRight");
	TradeSkillFrameTR:ClearAllPoints();
	TradeSkillFrameTR:SetPoint("TOPLEFT",TradeSkillFrameTL,"TOPRIGHT",0,0);
	TradeSkillFrameBR:ClearAllPoints();
	TradeSkillFrameBR:SetPoint("BOTTOMLEFT",TradeSkillFrameBL,"BOTTOMRIGHT",0,0);
	TradeSkillFrameBR:SetWidth(256);
	TradeSkillFrameBR:SetHeight(256);
    TradeSkillFrameBR:SetTexture("Interface\\AddOns\\TradeSkillHD\\UI-TradeSkill-BottomRight");
	TradeSkillHorizontalBarLeft:ClearAllPoints();
	TradeSkillHorizontalBarLeft:SetPoint("TOP",TradeSkillFrame,"TOP",-17,-90);
	TradeSkillRankFrameBorder:SetTexture("Interface\\AddOns\\TradeSkillHD\\UI-TradeSkill-BarFix1");
	local t = TradeSkillRankFrame:CreateTexture(nil, "BORDER");
	t:ClearAllPoints();
	t:SetPoint("LEFT", TradeSkillRankFrameBorder,"RIGHT",0,0);
	t:SetWidth(274);
	t:SetHeight(27);
	t:SetTexture("Interface\\AddOns\\TradeSkillHD\\UI-TradeSkill-BarFix2");
	r = TradeSkillRankFrame:CreateTexture(nil, "BORDER")
    r:ClearAllPoints();
    r:SetPoint("LEFT", t, "RIGHT", 0,0);
    r:SetWidth(137);
    r:SetHeight(27);
	r:SetTexture("Interface\\AddOns\\TradeSkillHD\\UI-TradeSkill-BarFix3");
	local sc={TradeSkillListScrollFrame:GetRegions()}
	local s=sc[1]
	s:SetWidth(30)
	s:SetHeight(253)
	s:ClearAllPoints()
	s:SetPoint("TOPLEFT", TradeSkillListScrollFrame, "TOPRIGHT", -2, 2 )
	s:SetTexture([[Interface\PaperDollInfoFrame\UI-Character-ScrollBar]])
	s:SetTexCoord(0, 0.46875, 0.01171875, 1.0)
	s:Show()
	s=sc[2]
	s:Show()
	s:SetWidth(30)
	s:SetHeight(108)
	s:ClearAllPoints()
	s:SetPoint("BOTTOMLEFT", TradeSkillListScrollFrame, "BOTTOMRIGHT", -2, -4 )
	s:SetTexture([[Interface\PaperDollInfoFrame\UI-Character-ScrollBar]])
	s:SetTexCoord(0.515625, 0.984375, 0, 0.421875)
	sc={TradeSkillDetailScrollFrame:GetRegions()}
	s=sc[1]
	s:SetWidth(30)
	s:SetHeight(253)
	s:ClearAllPoints()
	s:SetPoint("TOPLEFT", TradeSkillDetailScrollFrame, "TOPRIGHT", -2, 2 )
	s:SetTexture([[Interface\PaperDollInfoFrame\UI-Character-ScrollBar]])
	s:SetTexCoord(0, 0.46875, 0.01171875, 1.0)
	s:Show()
	s=sc[2]
	s:Show()
	s:SetWidth(30)
	s:SetHeight(108)
	s:ClearAllPoints()
	s:SetPoint("BOTTOMLEFT", TradeSkillDetailScrollFrame, "BOTTOMRIGHT", -2, -4 )
	s:SetTexture([[Interface\PaperDollInfoFrame\UI-Character-ScrollBar]])
	s:SetTexCoord(0.515625, 0.984375, 0, 0.421875)
	TradeSkillFrame_LoadUI = TradeSkillFrameReset
end;

TradeSkillFrameSSOverride = function(id)
	local skillName, skillType, numAvailable, isExpanded, altVerb = GetTradeSkillInfo(id);
	local creatable = 1;
	if ( not skillName ) then creatable = nil; end;
	TradeSkillHighlightFrame:Show();
	if ( skillType == "header" ) then
		TradeSkillHighlightFrame:Hide();
		if ( isExpanded ) then CollapseTradeSkillSubClass(id); else	ExpandTradeSkillSubClass(id); end;
		return;
	end;
	TradeSkillFrame.selectedSkill = id;
	SelectTradeSkill(id);
	if ( GetTradeSkillSelectionIndex() > GetNumTradeSkills() ) then	return;	end;
	local color = TradeSkillTypeColor[skillType];
	if ( color ) then TradeSkillHighlight:SetVertexColor(color.r, color.g, color.b); end;
	local skillLineName, skillLineRank, skillLineMaxRank = GetTradeSkillLine();
	TradeSkillFrameTitleText:SetFormattedText(TRADE_SKILL_TITLE, skillLineName);
	TradeSkillRankFrame:SetStatusBarColor(0.0, 0.0, 1.0, 0.5);
	TradeSkillRankFrameBackground:SetVertexColor(0.0, 0.0, 0.75, 0.5);
	TradeSkillRankFrame:SetMinMaxValues(0, skillLineMaxRank);
	TradeSkillRankFrame:SetValue(skillLineRank);
	TradeSkillRankFrameSkillRank:SetText(skillLineRank.."/"..skillLineMaxRank);
	TradeSkillSkillName:SetText(skillName);
	if ( GetTradeSkillCooldown(id) ) then
		TradeSkillSkillCooldown:SetText(COOLDOWN_REMAINING.." "..SecondsToTime(GetTradeSkillCooldown(id)));
	else
		TradeSkillSkillCooldown:SetText("");
	end;
	TradeSkillSkillIcon:SetNormalTexture(GetTradeSkillIcon(id));
	local minMade,maxMade = GetTradeSkillNumMade(id);
	if ( maxMade > 1 ) then
		if ( minMade == maxMade ) then
			TradeSkillSkillIconCount:SetText(minMade);
		else
			TradeSkillSkillIconCount:SetText(minMade.."-"..maxMade);
		end
		if ( TradeSkillSkillIconCount:GetWidth() > 39 ) then
			TradeSkillSkillIconCount:SetText("~"..floor((minMade + maxMade)/2));
		end
	else
		TradeSkillSkillIconCount:SetText("");
	end;
	local numReagents = GetTradeSkillNumReagents(id);
	if(numReagents > 0) then
		TradeSkillReagentLabel:Show();
	else
		TradeSkillReagentLabel:Hide();
	end;
	for i=1, numReagents, 1 do
		local reagentName, reagentTexture, reagentCount, playerReagentCount = GetTradeSkillReagentInfo(id, i);
		local reagent = getglobal("TradeSkillReagent"..i)
		local name = getglobal("TradeSkillReagent"..i.."Name");
		local count = getglobal("TradeSkillReagent"..i.."Count");
		if ( not reagentName or not reagentTexture ) then
			reagent:Hide();
		else
			reagent:Show();
			SetItemButtonTexture(reagent, reagentTexture);
			name:SetText(reagentName);
			if ( playerReagentCount < reagentCount ) then
				SetItemButtonTextureVertexColor(reagent, 0.5, 0.5, 0.5);
				name:SetTextColor(GRAY_FONT_COLOR.r, GRAY_FONT_COLOR.g, GRAY_FONT_COLOR.b);
				creatable = nil;
			else
				SetItemButtonTextureVertexColor(reagent, 1.0, 1.0, 1.0);
				name:SetTextColor(HIGHLIGHT_FONT_COLOR.r, HIGHLIGHT_FONT_COLOR.g, HIGHLIGHT_FONT_COLOR.b);
			end;
			if ( playerReagentCount >= 100 ) then playerReagentCount = "*";	end;
			count:SetText(playerReagentCount.." /"..reagentCount);
		end;
	end;
	local reagentToAnchorTo = numReagents;
	if ( (numReagents > 0) and (mod(numReagents, 2) == 0) ) then
		reagentToAnchorTo = reagentToAnchorTo - 1;
	end;
	for i=numReagents + 1, MAX_TRADE_SKILL_REAGENTS, 1 do
		getglobal("TradeSkillReagent"..i):Hide();
	end;
	local spellFocus = BuildColoredListString(GetTradeSkillTools(id));
	if ( spellFocus ) then
		TradeSkillRequirementLabel:Show();
		TradeSkillRequirementText:SetText(spellFocus);
	else
		TradeSkillRequirementLabel:Hide();
		TradeSkillRequirementText:SetText("");
	end;
	if ( creatable ) then
		TradeSkillCreateButton:Enable();
		TradeSkillCreateAllButton:Enable();
	else
		TradeSkillCreateButton:Disable();
		TradeSkillCreateAllButton:Disable();
	end;
	if ( GetTradeSkillDescription(id) ) then
		TradeSkillDescription:SetText(GetTradeSkillDescription(id))
		TradeSkillReagentLabel:SetPoint("TOPLEFT", "TradeSkillDescription", "BOTTOMLEFT", 0, -10);
	else
		TradeSkillDescription:SetText(" ");
		TradeSkillReagentLabel:SetPoint("TOPLEFT", "TradeSkillDescription", "TOPLEFT", 0, 0);
	end;
	TradeSkillInputBox:SetNumber(GetTradeskillRepeatCount());
	if ( IsTradeSkillLinked() ) then
		TradeSkillCreateButton:Hide();
		TradeSkillCreateAllButton:Hide();
		TradeSkillDecrementButton:Hide();
		TradeSkillInputBox:Hide();
		TradeSkillIncrementButton:Hide();
		TradeSkillLinkButton:Hide();
	else
		if ( not altVerb ) then
			TradeSkillCreateAllButton:Show();
			TradeSkillDecrementButton:Show();
			TradeSkillInputBox:Show();
			TradeSkillIncrementButton:Show();
		else
			TradeSkillCreateAllButton:Hide();
			TradeSkillDecrementButton:Hide();
			TradeSkillInputBox:Hide();
			TradeSkillIncrementButton:Hide();
		end;
		if ( GetTradeSkillListLink() ) then TradeSkillLinkButton:Show(); else TradeSkillLinkButton:Hide(); end;
		TradeSkillCreateButton:SetText(altVerb or CREATE);
		TradeSkillCreateButton:Show();
    end	;
end;